<template>
	<div class="w-full md:w-570 lg:w-690 mx-auto justify-center items-center relative">
		<p
			class="font-secondary-font-regular text-center px-4 pt-8 pb-6 md:px-0 md:pb-4 lg:pt-16 lg:pb-10 text-28 md:text-base2 lg:text-5xl leading-8 md:leading-10"
		>
			Time to register your gift.
		</p>
		<p class="font-primary-font-light text-center lg:text-base lg:leading-6 px-4 lg:px-6 pb-8 md:pb-4 lg:pb-2">
			Get better customer support, save on filter refills, and receive special offers and updates.
		</p>
		<p class="pb-8 md:pb-6 lg:pb-4 text-center">
			<span class="px-2 font-secondary-font-regular text-28 md:text-base2 leading-8 md:leading-10 mk-or-text text-black"
				>or</span
			>
		</p>
		<p class="font-primary-font-light text-base leading-6 text-center">
			Register with the app by connecting your device.
		</p>
		<div class="flex justify-center gap-x-4 mt-9 md:mt-6">
			<a href="https://apps.apple.com/us/app/molekule-the-air-you-were-meant-to-breathe/id1219881640" target="_blank"
				><img src="~/assets/images/icon-app-store.svg" class="h-10 mr-9 md:mr-4 lg:mr-6" alt="icon-app-store"
			/></a>
			<a href="https://play.google.com/store/apps/details?id=com.molekule.android" target="_blank"
				><img src="~/assets/images/icon-google-play.svg" class="h-10" alt="icon-google-play"
			/></a>
		</div>
		<MkDeviceDetails
			class="mt-10 md:mt-10 lg:mt-14"
			:steps-completed="stepsCompleted"
			:value="deviceDetails"
			:title="accountTitle"
			:estimated-date="'Est. receipt date'"
			gift
			@completedstep="completedstep"
			@input="updateDetails"
			@change-view="changeView"
			@edit-device="editDevice"
		/>
		<MkCreateAccount
			class="md:mb-28 lg:mb-32"
			:steps-completed="stepsCompleted"
			:value="accountDetails"
			:title="accountTitle"
			:estimated-date="'Est. receipt date'"
			gift
			@sign-in="userExist"
			:deviceDetails="deviceDetails"
			@device-register-fail="deviceRegisterFail"
		/>
	</div>
</template>
<script>
import { mapState } from 'vuex';
import MkDeviceDetails from '~/components/D2C/organisms/MkDeviceDetails.vue';
import MkCreateAccount from '~/components/D2C/molecules/MkCreateAccount.vue';
export default {
	name: 'MkGiftRegister',
	components: {
		MkDeviceDetails,
		MkCreateAccount,
	},
	data() {
		return {
			stepsCompleted: 1,
			deviceDetails: {
				serialNumber: '',
				purchaseDate: '',
			},
			accountDetails: {},
			editing: false,
			previousStepsCompleted: null,
			accountTitle: 'Create account',
		};
	},
	computed: {
		...mapState('USER_STORE', ['AUTHENTICATED', 'CUSTOMER_EMAIL']),
	},
	watch: {
		AUTHENTICATED: {
			deep: true,
			handler() {
				this.setAccount();
			},
		},
	},
	mounted() {
		this.setAccount();
	},
	methods: {
		completedstep() {
			if (!this.editing) {
				if (this.stepsCompleted !== 2) {
					this.stepsCompleted++;
				}
			} else {
				this.editing = false;
				this.stepsCompleted = this.previousStepsCompleted;
			}
		},
		updateDetails(value) {
			this.deviceDetails = value;
		},
		changeView(value) {
			if (!value) {
				this.accountTitle = 'Device details';
			} else {
				this.accountTitle = 'Create account';
			}
			this.deviceDetails = {}
		},
		setAccount() {
			if (this.AUTHENTICATED) {
				this.stepsCompleted = 2;
				this.accountTitle = 'Device details';
			}
		},
		editDevice() {
			this.stepsCompleted = 1;
			if (this.AUTHENTICATED) {
				this.deviceDetails.email = this.CUSTOMER_EMAIL;
			}
		},
		userExist(value){
			this.stepsCompleted = 1;
			this.deviceDetails.email = value['quick_reg_email_address'] || '';
			this.accountTitle = 'Device details';
			this.accountDetails = {}
			if(this.DEVICE && this.DEVICE.serialNumber){
				this.accountDetails = {
					purchaseDate:this.DEVICE.purchaseDate,
					serialNumber:this.DEVICE.serialNumber,
					deviceId:this.DEVICE.deviceId,
					gift:this.DEVICE.gift
				}
			}
		},
		deviceRegisterFail(value) {
			this.accountTitle = 'Device details';
			this.deviceDetails = {}
			this.accountDetails = {};
			if(value){
				this.accountDetails = value;
			}
		}
	}
};
</script>
